commit:     e772be31b041cd55f138130fcc9c2cc418847581
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Fri Sep 16 21:48:11 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Fri Sep 16 21:50:45 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=e772be31

net-fs/nfs-utils: fix build with -Werror=strict-prototypes (Clang 15+)

Closes: https://bugs.gentoo.org/869254
Signed-off-by: Sam James <sam <AT> gentoo.org>

 ...tils-2.6.2-clang-Wlogical-not-parentheses.patch |  28 +++
 ...utils-2.6.2-clang-fix-function-prototypes.patch |  78 +++++++
 ...tils-2.6.2-clang-more-function-prototypes.patch |  37 ++++
 net-fs/nfs-utils/nfs-utils-2.6.2-r1.ebuild         | 231 +++++++++++++++++++++
 4 files changed, 374 insertions(+)

diff --git 
a/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-Wlogical-not-parentheses.patch 
b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-Wlogical-not-parentheses.patch
new file mode 100644
index 000000000000..2ba9a45a024b
--- /dev/null
+++ 
b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-Wlogical-not-parentheses.patch
@@ -0,0 +1,28 @@
+https://git.linux-nfs.org/?p=steved/nfs-utils.git;a=commitdiff;h=896946e3c7f8ec1a02d4dc3a039e6cbbd2f611a9
+
+From 896946e3c7f8ec1a02d4dc3a039e6cbbd2f611a9 Mon Sep 17 00:00:00 2001
+From: Khem Raj <raj.k...@gmail.com>
+Date: Tue, 13 Sep 2022 11:42:03 -0400
+Subject: [PATCH] mountd: Check for return of stat function
+
+simplify the check, stat() return 0 on success -1 on failure
+
+Fixes clang reported errors e.g.
+
+| v4clients.c:29:6: error: logical not is only applied to the left hand side 
of this comparison [-Werror,-Wlogical-not-parentheses]
+|         if (!stat("/proc/fs/nfsd/clients", &sb) == 0 ||
+|             ^                                   ~~
+
+Signed-off-by: Khem Raj <raj.k...@gmail.com>
+Signed-off-by: Steve Dickson <ste...@redhat.com>
+--- a/support/export/v4clients.c
++++ b/support/export/v4clients.c
+@@ -26,7 +26,7 @@ void v4clients_init(void)
+ {
+       struct stat sb;
+ 
+-      if (!stat("/proc/fs/nfsd/clients", &sb) == 0 ||
++      if (stat("/proc/fs/nfsd/clients", &sb) != 0 ||
+           !S_ISDIR(sb.st_mode))
+               return;
+       if (clients_fd >= 0)

diff --git 
a/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-fix-function-prototypes.patch 
b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-fix-function-prototypes.patch
new file mode 100644
index 000000000000..f223af883ad0
--- /dev/null
+++ b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-fix-function-prototypes.patch
@@ -0,0 +1,78 @@
+https://git.linux-nfs.org/?p=steved/nfs-utils.git;a=commitdiff;h=167f2336b06e1bcbf26f45f2ddc4a535fed4d393
+https://bugs.gentoo.org/869254
+
+From 167f2336b06e1bcbf26f45f2ddc4a535fed4d393 Mon Sep 17 00:00:00 2001
+From: Khem Raj <raj.k...@gmail.com>
+Date: Tue, 13 Sep 2022 11:44:05 -0400
+Subject: [PATCH] Fix function prototypes
+
+Clang is now erroring out on functions with out parameter types
+
+Fixes errors like
+error: a function declaration without a prototype is deprecated in all 
versions of C [-Werror,-Wstrict-prototypes]
+
+Signed-off-by: Khem Raj <raj.k...@gmail.com>
+Signed-off-by: Steve Dickson <ste...@redhat.com>
+--- a/support/export/auth.c
++++ b/support/export/auth.c
+@@ -82,7 +82,7 @@ check_useipaddr(void)
+ }
+ 
+ unsigned int
+-auth_reload()
++auth_reload(void)
+ {
+       struct stat             stb;
+       static ino_t            last_inode;
+--- a/support/export/v4root.c
++++ b/support/export/v4root.c
+@@ -198,7 +198,7 @@ static int v4root_add_parents(nfs_export *exp)
+  * looking for components of the v4 mount.
+  */
+ void
+-v4root_set()
++v4root_set(void)
+ {
+       nfs_export      *exp;
+       int     i;
+--- a/support/export/xtab.c
++++ b/support/export/xtab.c
+@@ -135,7 +135,7 @@ xtab_write(char *xtab, char *xtabtmp, char *lockfn, int 
is_export)
+ }
+ 
+ int
+-xtab_export_write()
++xtab_export_write(void)
+ {
+       return xtab_write(etab.statefn, etab.tmpfn, etab.lockfn, 1);
+ }
+--- a/utils/exportfs/exportfs.c
++++ b/utils/exportfs/exportfs.c
+@@ -69,14 +69,14 @@ static int _lockfd = -1;
+  * need these additional lockfile() routines.
+  */
+ static void
+-grab_lockfile()
++grab_lockfile(void)
+ {
+       _lockfd = open(lockfile, O_CREAT|O_RDWR, 0666);
+       if (_lockfd != -1)
+               lockf(_lockfd, F_LOCK, 0);
+ }
+ static void
+-release_lockfile()
++release_lockfile(void)
+ {
+       if (_lockfd != -1) {
+               lockf(_lockfd, F_ULOCK, 0);
+--- a/utils/mount/network.c
++++ b/utils/mount/network.c
+@@ -179,7 +179,7 @@ static const unsigned long probe_mnt3_only[] = {
+ 
+ static const unsigned int *nfs_default_proto(void);
+ #ifdef MOUNT_CONFIG
+-static const unsigned int *nfs_default_proto()
++static const unsigned int *nfs_default_proto(void)
+ {
+       extern unsigned long config_default_proto;
+       /*

diff --git 
a/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-more-function-prototypes.patch 
b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-more-function-prototypes.patch
new file mode 100644
index 000000000000..aecb29d3a7cf
--- /dev/null
+++ 
b/net-fs/nfs-utils/files/nfs-utils-2.6.2-clang-more-function-prototypes.patch
@@ -0,0 +1,37 @@
+From daf6aa9b659078aebd202fffff59bd9a0ab685ce Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Fri, 16 Sep 2022 22:35:23 +0100
+Subject: [PATCH] Fix more function prototypes
+
+```
+regex.c:545:43: error: a function declaration without a prototype is 
deprecated in all versions of C [-Werror,-Wstrict-prototypes]
+struct trans_func *libnfsidmap_plugin_init()
+                                          ^
+                                           void
+1 error generated.
+```
+
+See: 167f2336b06e1bcbf26f45f2ddc4a535fed4d393
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/support/nfsidmap/regex.c
++++ b/support/nfsidmap/regex.c
+@@ -542,7 +542,7 @@ struct trans_func regex_trans = {
+       .gss_princ_to_grouplist = regex_gss_princ_to_grouplist,
+ };
+ 
+-struct trans_func *libnfsidmap_plugin_init()
++struct trans_func *libnfsidmap_plugin_init(void)
+ {
+       return (&regex_trans);
+ }
+--- a/utils/idmapd/idmapd.c
++++ b/utils/idmapd/idmapd.c
+@@ -867,7 +867,7 @@ nfsdreopen_one(struct idmap_client *ic)
+ }
+ 
+ static void
+-nfsdreopen()
++nfsdreopen(void)
+ {
+       nfsdreopen_one(&nfsd_ic[IC_NAMEID]);
+       nfsdreopen_one(&nfsd_ic[IC_IDNAME]);

diff --git a/net-fs/nfs-utils/nfs-utils-2.6.2-r1.ebuild 
b/net-fs/nfs-utils/nfs-utils-2.6.2-r1.ebuild
new file mode 100644
index 000000000000..09bbf816fdea
--- /dev/null
+++ b/net-fs/nfs-utils/nfs-utils-2.6.2-r1.ebuild
@@ -0,0 +1,231 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit autotools linux-info systemd
+
+DESCRIPTION="NFS client and server daemons"
+HOMEPAGE="http://linux-nfs.org/ 
https://git.linux-nfs.org/?p=steved/nfs-utils.git";
+
+if [[ ${PV} == *_rc* ]] ; then
+       MY_PV="$(ver_rs 1- -)"
+       
SRC_URI="http://git.linux-nfs.org/?p=steved/nfs-utils.git;a=snapshot;h=refs/tags/${PN}-${MY_PV};sf=tgz
 -> ${P}.tar.gz"
+       S="${WORKDIR}/${PN}-${PN}-${MY_PV}"
+else
+       SRC_URI="mirror://sourceforge/nfs/${P}.tar.bz2"
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~mips ~ppc 
~ppc64 ~riscv ~s390 ~sparc ~x86"
+fi
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="caps junction kerberos ldap +libmount nfsdcld +nfsidmap +nfsv4 nfsv41 
sasl selinux tcpd +uuid"
+REQUIRED_USE="kerberos? ( nfsv4 )"
+# bug #315573
+RESTRICT="test"
+
+# kth-krb doesn't provide the right include
+# files, and nfs-utils doesn't build against heimdal either,
+# so don't depend on virtual/krb.
+# (04 Feb 2005 agriffis)
+COMMON_DEPEND="
+       dev-libs/libxml2
+       net-libs/libtirpc:=
+       >=net-nds/rpcbind-0.2.4
+       sys-fs/e2fsprogs
+       caps? ( sys-libs/libcap )
+       ldap? (
+               net-nds/openldap:=
+               sasl? (
+                       app-crypt/mit-krb5
+                       dev-libs/cyrus-sasl:2
+               )
+       )
+       libmount? ( sys-apps/util-linux )
+       nfsv4? (
+               dev-db/sqlite:3
+               dev-libs/libevent:=
+               >=sys-apps/keyutils-1.5.9:=
+               kerberos? (
+                       >=net-libs/libtirpc-0.2.4-r1[kerberos]
+                       app-crypt/mit-krb5
+               )
+       )
+       nfsv41? (
+               sys-fs/lvm2
+       )
+       tcpd? ( sys-apps/tcp-wrappers )
+       uuid? ( sys-apps/util-linux )"
+DEPEND="${COMMON_DEPEND}
+       elibc_musl? ( sys-libs/queue-standalone )
+"
+RDEPEND="${COMMON_DEPEND}
+       !net-libs/libnfsidmap
+       selinux? (
+               sec-policy/selinux-rpc
+               sec-policy/selinux-rpcbind
+       )
+"
+BDEPEND="
+       net-libs/rpcsvc-proto
+       virtual/pkgconfig
+"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-2.5.2-no-werror.patch
+       "${FILESDIR}"/${P}-clang-Wlogical-not-parentheses.patch
+       "${FILESDIR}"/${P}-clang-fix-function-prototypes.patch
+       "${FILESDIR}"/${PN}-2.6.2-clang-more-function-prototypes.patch
+)
+
+pkg_setup() {
+       linux-info_pkg_setup
+
+       if use nfsv4 && ! use nfsdcld && linux_config_exists && ! 
linux_chkconfig_present CRYPTO_MD5 ; then
+               ewarn "Your NFS server will be unable to track clients across 
server restarts!"
+               ewarn "Please enable the \"${HILITE}nfsdcld${NORMAL}\" USE flag 
to install the nfsdcltrack usermode"
+               ewarn "helper upcall program, or enable 
${HILITE}CONFIG_CRYPTO_MD5${NORMAL} in your kernel to"
+               ewarn "support the legacy, in-kernel client tracker."
+       fi
+}
+
+src_prepare() {
+       default
+
+       sed \
+               -e "/^sbindir/s:= := \"${EPREFIX}\":g" \
+               -i utils/*/Makefile.am || die
+
+       eautoreconf
+}
+
+src_configure() {
+       # Our DEPEND forces this.
+       export libsqlite3_cv_is_recent=yes
+       export ac_cv_header_keyutils_h=$(usex nfsidmap)
+
+       # SASL is consumed in a purely automagic way
+       export ac_cv_header_sasl_h=no
+       export ac_cv_header_sasl_sasl_h=$(usex sasl)
+
+       local myeconfargs=(
+               --disable-static
+               --with-statedir="${EPREFIX}"/var/lib/nfs
+               --enable-tirpc
+               --with-tirpcinclude="${ESYSROOT}"/usr/include/tirpc/
+               --with-pluginpath="${EPREFIX}"/usr/$(get_libdir)/libnfsidmap
+               --with-rpcgen
+               --with-systemd="$(systemd_get_systemunitdir)"
+               --without-gssglue
+               $(use_enable caps)
+               --enable-ipv6
+               $(use_enable junction)
+               $(use_enable kerberos gss)
+               $(use_enable kerberos svcgss)
+               $(use_enable ldap)
+               $(use_enable libmount libmount-mount)
+               $(use_enable nfsdcld nfsdcltrack)
+               $(use_enable nfsv4)
+               $(use_enable nfsv41)
+               $(use_enable uuid)
+               $(use_with tcpd tcp-wrappers)
+       )
+       econf "${myeconfargs[@]}"
+}
+
+src_compile() {
+       # Remove compiled files bundled in the tarball
+       emake clean
+
+       default
+}
+
+src_install() {
+       default
+       rm linux-nfs/Makefile* || die
+       dodoc -r linux-nfs README
+
+       # Don't overwrite existing xtab/etab, install the original
+       # versions somewhere safe...  more info in pkg_postinst
+       keepdir /var/lib/nfs/{,sm,sm.bak}
+       mv "${ED}"/var/lib/nfs "${ED}"/usr/$(get_libdir)/ || die
+
+       # Install some client-side binaries in /sbin
+       dodir /sbin
+       mv "${ED}"/usr/sbin/rpc.statd "${ED}"/sbin/ || die
+
+       if use nfsv4 && use nfsidmap ; then
+               insinto /etc
+               doins support/nfsidmap/idmapd.conf
+
+               # Install a config file for idmappers in newer kernels. bug 
#415625
+               insinto /etc/request-key.d
+               echo 'create id_resolver * * /usr/sbin/nfsidmap -t 600 %k %d' > 
id_resolver.conf
+               doins id_resolver.conf
+       fi
+
+       insinto /etc
+       doins "${FILESDIR}"/exports
+       keepdir /etc/exports.d
+
+       local f list=() opt_need=""
+       if use nfsv4 ; then
+               opt_need="rpc.idmapd"
+               list+=( rpc.idmapd rpc.pipefs )
+               use kerberos && list+=( rpc.gssd rpc.svcgssd )
+       fi
+       for f in nfs nfsclient rpc.statd "${list[@]}" ; do
+               newinitd "${FILESDIR}"/${f}.initd ${f}
+       done
+
+       # Nuke after 2015/08/01
+       newinitd "${FILESDIR}"/nfsmount.initd-1.3.1 nfsmount
+       for f in nfs nfsclient ; do
+               newconfd "${FILESDIR}"/${f}.confd ${f}
+       done
+
+       # bug #234132
+       sed -i \
+               -e "/^NFS_NEEDED_SERVICES=/s:=.*:=\"${opt_need}\":" \
+               "${ED}"/etc/conf.d/nfs || die
+
+       local systemd_systemunitdir="$(systemd_get_systemunitdir)"
+       sed -i \
+               -e 's:/usr/sbin/rpc.statd:/sbin/rpc.statd:' \
+               "${ED}${systemd_systemunitdir}"/* || die
+
+       # bug #368505
+       keepdir /var/lib/nfs
+       # bug #603628
+       keepdir /var/lib/nfs/v4recovery
+
+       # No static archives
+       find "${ED}" -name '*.la' -delete || die
+}
+
+pkg_postinst() {
+       # Install default xtab and friends if there's none existing.  In
+       # src_install we put them in /usr/lib/nfs for safe-keeping, but
+       # the daemons actually use the files in /var/lib/nfs.  #30486
+       local f
+       for f in "${EROOT}"/usr/$(get_libdir)/nfs/*; do
+               [[ -e ${EROOT}/var/lib/nfs/${f##*/} ]] && continue
+               einfo "Copying default ${f##*/} from 
${EPREFIX}/usr/$(get_libdir)/nfs to ${EPREFIX}/var/lib/nfs"
+               cp -pPR "${f}" "${EROOT}"/var/lib/nfs/
+       done
+
+       if systemd_is_booted; then
+               for v in ${REPLACING_VERSIONS}; do
+                       if ver_test "${v}" -lt 1.3.0; then
+                               ewarn "We have switched to upstream systemd 
unit files. Since"
+                               ewarn "they got renamed, you should probably 
enable the new ones."
+                               ewarn "You can run 'equery files nfs-utils | 
grep systemd'"
+                               ewarn "to know what services you need to enable 
now."
+                       fi
+               done
+       else
+               ewarn "If you use OpenRC, the nfsmount service has been 
replaced with nfsclient."
+               ewarn "If you were using nfsmount, please add nfsclient and 
netmount to the"
+               ewarn "same runlevel as nfsmount."
+       fi
+}

Reply via email to